// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: essmodule/essmodule.proto

package openfmb.essmodule;

/**
 * <pre>
 * ESS inverter high level function to reduce (smooth) charging or discharging rate of change.
 * </pre>
 *
 * Protobuf type {@code essmodule.CapacityFirming}
 */
public final class CapacityFirming extends
    com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:essmodule.CapacityFirming)
    CapacityFirmingOrBuilder {
private static final long serialVersionUID = 0L;
  // Use CapacityFirming.newBuilder() to construct.
  private CapacityFirming(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private CapacityFirming() {
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(
      UnusedPrivateParameter unused) {
    return new CapacityFirming();
  }

  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return openfmb.essmodule.Essmodule.internal_static_essmodule_CapacityFirming_descriptor;
  }

  @java.lang.Override
  protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return openfmb.essmodule.Essmodule.internal_static_essmodule_CapacityFirming_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            openfmb.essmodule.CapacityFirming.class, openfmb.essmodule.CapacityFirming.Builder.class);
  }

  public static final int CAPACITYFIRMINGCTL_FIELD_NUMBER = 1;
  private com.google.protobuf.BoolValue capacityFirmingCtl_;
  /**
   * <pre>
   * Control value (TRUE or FALSE)
   * </pre>
   *
   * <code>.google.protobuf.BoolValue capacityFirmingCtl = 1;</code>
   * @return Whether the capacityFirmingCtl field is set.
   */
  @java.lang.Override
  public boolean hasCapacityFirmingCtl() {
    return capacityFirmingCtl_ != null;
  }
  /**
   * <pre>
   * Control value (TRUE or FALSE)
   * </pre>
   *
   * <code>.google.protobuf.BoolValue capacityFirmingCtl = 1;</code>
   * @return The capacityFirmingCtl.
   */
  @java.lang.Override
  public com.google.protobuf.BoolValue getCapacityFirmingCtl() {
    return capacityFirmingCtl_ == null ? com.google.protobuf.BoolValue.getDefaultInstance() : capacityFirmingCtl_;
  }
  /**
   * <pre>
   * Control value (TRUE or FALSE)
   * </pre>
   *
   * <code>.google.protobuf.BoolValue capacityFirmingCtl = 1;</code>
   */
  @java.lang.Override
  public com.google.protobuf.BoolValueOrBuilder getCapacityFirmingCtlOrBuilder() {
    return capacityFirmingCtl_ == null ? com.google.protobuf.BoolValue.getDefaultInstance() : capacityFirmingCtl_;
  }

  public static final int LIMITNEGATIVE_DP_DT_FIELD_NUMBER = 2;
  private com.google.protobuf.FloatValue limitNegativeDpDt_;
  /**
   * <pre>
   * uint/1kW/min  If the supervised power increases at a rate higher that the rate defined by these
   * limits, the ESS will discharge/charge at an opposite dp/dt to reduce (smooth) the rate of change at
   * the PCC
   * </pre>
   *
   * <code>.google.protobuf.FloatValue limitNegative_dp_dt = 2;</code>
   * @return Whether the limitNegativeDpDt field is set.
   */
  @java.lang.Override
  public boolean hasLimitNegativeDpDt() {
    return limitNegativeDpDt_ != null;
  }
  /**
   * <pre>
   * uint/1kW/min  If the supervised power increases at a rate higher that the rate defined by these
   * limits, the ESS will discharge/charge at an opposite dp/dt to reduce (smooth) the rate of change at
   * the PCC
   * </pre>
   *
   * <code>.google.protobuf.FloatValue limitNegative_dp_dt = 2;</code>
   * @return The limitNegativeDpDt.
   */
  @java.lang.Override
  public com.google.protobuf.FloatValue getLimitNegativeDpDt() {
    return limitNegativeDpDt_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : limitNegativeDpDt_;
  }
  /**
   * <pre>
   * uint/1kW/min  If the supervised power increases at a rate higher that the rate defined by these
   * limits, the ESS will discharge/charge at an opposite dp/dt to reduce (smooth) the rate of change at
   * the PCC
   * </pre>
   *
   * <code>.google.protobuf.FloatValue limitNegative_dp_dt = 2;</code>
   */
  @java.lang.Override
  public com.google.protobuf.FloatValueOrBuilder getLimitNegativeDpDtOrBuilder() {
    return limitNegativeDpDt_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : limitNegativeDpDt_;
  }

  public static final int LIMITPOSITIVE_DP_DT_FIELD_NUMBER = 3;
  private com.google.protobuf.FloatValue limitPositiveDpDt_;
  /**
   * <pre>
   * uint/1kW/min  If the supervised power increases at a rate higher that the rate defined by these
   * limits, the ESS will discharge/charge at an opposite dp/dt to reduce (smooth) the rate of change at
   * the PCC
   * </pre>
   *
   * <code>.google.protobuf.FloatValue limitPositive_dp_dt = 3;</code>
   * @return Whether the limitPositiveDpDt field is set.
   */
  @java.lang.Override
  public boolean hasLimitPositiveDpDt() {
    return limitPositiveDpDt_ != null;
  }
  /**
   * <pre>
   * uint/1kW/min  If the supervised power increases at a rate higher that the rate defined by these
   * limits, the ESS will discharge/charge at an opposite dp/dt to reduce (smooth) the rate of change at
   * the PCC
   * </pre>
   *
   * <code>.google.protobuf.FloatValue limitPositive_dp_dt = 3;</code>
   * @return The limitPositiveDpDt.
   */
  @java.lang.Override
  public com.google.protobuf.FloatValue getLimitPositiveDpDt() {
    return limitPositiveDpDt_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : limitPositiveDpDt_;
  }
  /**
   * <pre>
   * uint/1kW/min  If the supervised power increases at a rate higher that the rate defined by these
   * limits, the ESS will discharge/charge at an opposite dp/dt to reduce (smooth) the rate of change at
   * the PCC
   * </pre>
   *
   * <code>.google.protobuf.FloatValue limitPositive_dp_dt = 3;</code>
   */
  @java.lang.Override
  public com.google.protobuf.FloatValueOrBuilder getLimitPositiveDpDtOrBuilder() {
    return limitPositiveDpDt_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : limitPositiveDpDt_;
  }

  private byte memoizedIsInitialized = -1;
  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    if (capacityFirmingCtl_ != null) {
      output.writeMessage(1, getCapacityFirmingCtl());
    }
    if (limitNegativeDpDt_ != null) {
      output.writeMessage(2, getLimitNegativeDpDt());
    }
    if (limitPositiveDpDt_ != null) {
      output.writeMessage(3, getLimitPositiveDpDt());
    }
    getUnknownFields().writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (capacityFirmingCtl_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(1, getCapacityFirmingCtl());
    }
    if (limitNegativeDpDt_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(2, getLimitNegativeDpDt());
    }
    if (limitPositiveDpDt_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(3, getLimitPositiveDpDt());
    }
    size += getUnknownFields().getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof openfmb.essmodule.CapacityFirming)) {
      return super.equals(obj);
    }
    openfmb.essmodule.CapacityFirming other = (openfmb.essmodule.CapacityFirming) obj;

    if (hasCapacityFirmingCtl() != other.hasCapacityFirmingCtl()) return false;
    if (hasCapacityFirmingCtl()) {
      if (!getCapacityFirmingCtl()
          .equals(other.getCapacityFirmingCtl())) return false;
    }
    if (hasLimitNegativeDpDt() != other.hasLimitNegativeDpDt()) return false;
    if (hasLimitNegativeDpDt()) {
      if (!getLimitNegativeDpDt()
          .equals(other.getLimitNegativeDpDt())) return false;
    }
    if (hasLimitPositiveDpDt() != other.hasLimitPositiveDpDt()) return false;
    if (hasLimitPositiveDpDt()) {
      if (!getLimitPositiveDpDt()
          .equals(other.getLimitPositiveDpDt())) return false;
    }
    if (!getUnknownFields().equals(other.getUnknownFields())) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    if (hasCapacityFirmingCtl()) {
      hash = (37 * hash) + CAPACITYFIRMINGCTL_FIELD_NUMBER;
      hash = (53 * hash) + getCapacityFirmingCtl().hashCode();
    }
    if (hasLimitNegativeDpDt()) {
      hash = (37 * hash) + LIMITNEGATIVE_DP_DT_FIELD_NUMBER;
      hash = (53 * hash) + getLimitNegativeDpDt().hashCode();
    }
    if (hasLimitPositiveDpDt()) {
      hash = (37 * hash) + LIMITPOSITIVE_DP_DT_FIELD_NUMBER;
      hash = (53 * hash) + getLimitPositiveDpDt().hashCode();
    }
    hash = (29 * hash) + getUnknownFields().hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static openfmb.essmodule.CapacityFirming parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.essmodule.CapacityFirming parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.essmodule.CapacityFirming parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.essmodule.CapacityFirming parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.essmodule.CapacityFirming parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.essmodule.CapacityFirming parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.essmodule.CapacityFirming parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.essmodule.CapacityFirming parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.essmodule.CapacityFirming parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static openfmb.essmodule.CapacityFirming parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.essmodule.CapacityFirming parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.essmodule.CapacityFirming parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(openfmb.essmodule.CapacityFirming prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * <pre>
   * ESS inverter high level function to reduce (smooth) charging or discharging rate of change.
   * </pre>
   *
   * Protobuf type {@code essmodule.CapacityFirming}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:essmodule.CapacityFirming)
      openfmb.essmodule.CapacityFirmingOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return openfmb.essmodule.Essmodule.internal_static_essmodule_CapacityFirming_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return openfmb.essmodule.Essmodule.internal_static_essmodule_CapacityFirming_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              openfmb.essmodule.CapacityFirming.class, openfmb.essmodule.CapacityFirming.Builder.class);
    }

    // Construct using openfmb.essmodule.CapacityFirming.newBuilder()
    private Builder() {

    }

    private Builder(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);

    }
    @java.lang.Override
    public Builder clear() {
      super.clear();
      bitField0_ = 0;
      capacityFirmingCtl_ = null;
      if (capacityFirmingCtlBuilder_ != null) {
        capacityFirmingCtlBuilder_.dispose();
        capacityFirmingCtlBuilder_ = null;
      }
      limitNegativeDpDt_ = null;
      if (limitNegativeDpDtBuilder_ != null) {
        limitNegativeDpDtBuilder_.dispose();
        limitNegativeDpDtBuilder_ = null;
      }
      limitPositiveDpDt_ = null;
      if (limitPositiveDpDtBuilder_ != null) {
        limitPositiveDpDtBuilder_.dispose();
        limitPositiveDpDtBuilder_ = null;
      }
      return this;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return openfmb.essmodule.Essmodule.internal_static_essmodule_CapacityFirming_descriptor;
    }

    @java.lang.Override
    public openfmb.essmodule.CapacityFirming getDefaultInstanceForType() {
      return openfmb.essmodule.CapacityFirming.getDefaultInstance();
    }

    @java.lang.Override
    public openfmb.essmodule.CapacityFirming build() {
      openfmb.essmodule.CapacityFirming result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public openfmb.essmodule.CapacityFirming buildPartial() {
      openfmb.essmodule.CapacityFirming result = new openfmb.essmodule.CapacityFirming(this);
      if (bitField0_ != 0) { buildPartial0(result); }
      onBuilt();
      return result;
    }

    private void buildPartial0(openfmb.essmodule.CapacityFirming result) {
      int from_bitField0_ = bitField0_;
      if (((from_bitField0_ & 0x00000001) != 0)) {
        result.capacityFirmingCtl_ = capacityFirmingCtlBuilder_ == null
            ? capacityFirmingCtl_
            : capacityFirmingCtlBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000002) != 0)) {
        result.limitNegativeDpDt_ = limitNegativeDpDtBuilder_ == null
            ? limitNegativeDpDt_
            : limitNegativeDpDtBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000004) != 0)) {
        result.limitPositiveDpDt_ = limitPositiveDpDtBuilder_ == null
            ? limitPositiveDpDt_
            : limitPositiveDpDtBuilder_.build();
      }
    }

    @java.lang.Override
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof openfmb.essmodule.CapacityFirming) {
        return mergeFrom((openfmb.essmodule.CapacityFirming)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(openfmb.essmodule.CapacityFirming other) {
      if (other == openfmb.essmodule.CapacityFirming.getDefaultInstance()) return this;
      if (other.hasCapacityFirmingCtl()) {
        mergeCapacityFirmingCtl(other.getCapacityFirmingCtl());
      }
      if (other.hasLimitNegativeDpDt()) {
        mergeLimitNegativeDpDt(other.getLimitNegativeDpDt());
      }
      if (other.hasLimitPositiveDpDt()) {
        mergeLimitPositiveDpDt(other.getLimitPositiveDpDt());
      }
      this.mergeUnknownFields(other.getUnknownFields());
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10: {
              input.readMessage(
                  getCapacityFirmingCtlFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000001;
              break;
            } // case 10
            case 18: {
              input.readMessage(
                  getLimitNegativeDpDtFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000002;
              break;
            } // case 18
            case 26: {
              input.readMessage(
                  getLimitPositiveDpDtFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000004;
              break;
            } // case 26
            default: {
              if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                done = true; // was an endgroup tag
              }
              break;
            } // default:
          } // switch (tag)
        } // while (!done)
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.unwrapIOException();
      } finally {
        onChanged();
      } // finally
      return this;
    }
    private int bitField0_;

    private com.google.protobuf.BoolValue capacityFirmingCtl_;
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.BoolValue, com.google.protobuf.BoolValue.Builder, com.google.protobuf.BoolValueOrBuilder> capacityFirmingCtlBuilder_;
    /**
     * <pre>
     * Control value (TRUE or FALSE)
     * </pre>
     *
     * <code>.google.protobuf.BoolValue capacityFirmingCtl = 1;</code>
     * @return Whether the capacityFirmingCtl field is set.
     */
    public boolean hasCapacityFirmingCtl() {
      return ((bitField0_ & 0x00000001) != 0);
    }
    /**
     * <pre>
     * Control value (TRUE or FALSE)
     * </pre>
     *
     * <code>.google.protobuf.BoolValue capacityFirmingCtl = 1;</code>
     * @return The capacityFirmingCtl.
     */
    public com.google.protobuf.BoolValue getCapacityFirmingCtl() {
      if (capacityFirmingCtlBuilder_ == null) {
        return capacityFirmingCtl_ == null ? com.google.protobuf.BoolValue.getDefaultInstance() : capacityFirmingCtl_;
      } else {
        return capacityFirmingCtlBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * Control value (TRUE or FALSE)
     * </pre>
     *
     * <code>.google.protobuf.BoolValue capacityFirmingCtl = 1;</code>
     */
    public Builder setCapacityFirmingCtl(com.google.protobuf.BoolValue value) {
      if (capacityFirmingCtlBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        capacityFirmingCtl_ = value;
      } else {
        capacityFirmingCtlBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Control value (TRUE or FALSE)
     * </pre>
     *
     * <code>.google.protobuf.BoolValue capacityFirmingCtl = 1;</code>
     */
    public Builder setCapacityFirmingCtl(
        com.google.protobuf.BoolValue.Builder builderForValue) {
      if (capacityFirmingCtlBuilder_ == null) {
        capacityFirmingCtl_ = builderForValue.build();
      } else {
        capacityFirmingCtlBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Control value (TRUE or FALSE)
     * </pre>
     *
     * <code>.google.protobuf.BoolValue capacityFirmingCtl = 1;</code>
     */
    public Builder mergeCapacityFirmingCtl(com.google.protobuf.BoolValue value) {
      if (capacityFirmingCtlBuilder_ == null) {
        if (((bitField0_ & 0x00000001) != 0) &&
          capacityFirmingCtl_ != null &&
          capacityFirmingCtl_ != com.google.protobuf.BoolValue.getDefaultInstance()) {
          getCapacityFirmingCtlBuilder().mergeFrom(value);
        } else {
          capacityFirmingCtl_ = value;
        }
      } else {
        capacityFirmingCtlBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Control value (TRUE or FALSE)
     * </pre>
     *
     * <code>.google.protobuf.BoolValue capacityFirmingCtl = 1;</code>
     */
    public Builder clearCapacityFirmingCtl() {
      bitField0_ = (bitField0_ & ~0x00000001);
      capacityFirmingCtl_ = null;
      if (capacityFirmingCtlBuilder_ != null) {
        capacityFirmingCtlBuilder_.dispose();
        capacityFirmingCtlBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Control value (TRUE or FALSE)
     * </pre>
     *
     * <code>.google.protobuf.BoolValue capacityFirmingCtl = 1;</code>
     */
    public com.google.protobuf.BoolValue.Builder getCapacityFirmingCtlBuilder() {
      bitField0_ |= 0x00000001;
      onChanged();
      return getCapacityFirmingCtlFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * Control value (TRUE or FALSE)
     * </pre>
     *
     * <code>.google.protobuf.BoolValue capacityFirmingCtl = 1;</code>
     */
    public com.google.protobuf.BoolValueOrBuilder getCapacityFirmingCtlOrBuilder() {
      if (capacityFirmingCtlBuilder_ != null) {
        return capacityFirmingCtlBuilder_.getMessageOrBuilder();
      } else {
        return capacityFirmingCtl_ == null ?
            com.google.protobuf.BoolValue.getDefaultInstance() : capacityFirmingCtl_;
      }
    }
    /**
     * <pre>
     * Control value (TRUE or FALSE)
     * </pre>
     *
     * <code>.google.protobuf.BoolValue capacityFirmingCtl = 1;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.BoolValue, com.google.protobuf.BoolValue.Builder, com.google.protobuf.BoolValueOrBuilder> 
        getCapacityFirmingCtlFieldBuilder() {
      if (capacityFirmingCtlBuilder_ == null) {
        capacityFirmingCtlBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            com.google.protobuf.BoolValue, com.google.protobuf.BoolValue.Builder, com.google.protobuf.BoolValueOrBuilder>(
                getCapacityFirmingCtl(),
                getParentForChildren(),
                isClean());
        capacityFirmingCtl_ = null;
      }
      return capacityFirmingCtlBuilder_;
    }

    private com.google.protobuf.FloatValue limitNegativeDpDt_;
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder> limitNegativeDpDtBuilder_;
    /**
     * <pre>
     * uint/1kW/min  If the supervised power increases at a rate higher that the rate defined by these
     * limits, the ESS will discharge/charge at an opposite dp/dt to reduce (smooth) the rate of change at
     * the PCC
     * </pre>
     *
     * <code>.google.protobuf.FloatValue limitNegative_dp_dt = 2;</code>
     * @return Whether the limitNegativeDpDt field is set.
     */
    public boolean hasLimitNegativeDpDt() {
      return ((bitField0_ & 0x00000002) != 0);
    }
    /**
     * <pre>
     * uint/1kW/min  If the supervised power increases at a rate higher that the rate defined by these
     * limits, the ESS will discharge/charge at an opposite dp/dt to reduce (smooth) the rate of change at
     * the PCC
     * </pre>
     *
     * <code>.google.protobuf.FloatValue limitNegative_dp_dt = 2;</code>
     * @return The limitNegativeDpDt.
     */
    public com.google.protobuf.FloatValue getLimitNegativeDpDt() {
      if (limitNegativeDpDtBuilder_ == null) {
        return limitNegativeDpDt_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : limitNegativeDpDt_;
      } else {
        return limitNegativeDpDtBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * uint/1kW/min  If the supervised power increases at a rate higher that the rate defined by these
     * limits, the ESS will discharge/charge at an opposite dp/dt to reduce (smooth) the rate of change at
     * the PCC
     * </pre>
     *
     * <code>.google.protobuf.FloatValue limitNegative_dp_dt = 2;</code>
     */
    public Builder setLimitNegativeDpDt(com.google.protobuf.FloatValue value) {
      if (limitNegativeDpDtBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        limitNegativeDpDt_ = value;
      } else {
        limitNegativeDpDtBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/1kW/min  If the supervised power increases at a rate higher that the rate defined by these
     * limits, the ESS will discharge/charge at an opposite dp/dt to reduce (smooth) the rate of change at
     * the PCC
     * </pre>
     *
     * <code>.google.protobuf.FloatValue limitNegative_dp_dt = 2;</code>
     */
    public Builder setLimitNegativeDpDt(
        com.google.protobuf.FloatValue.Builder builderForValue) {
      if (limitNegativeDpDtBuilder_ == null) {
        limitNegativeDpDt_ = builderForValue.build();
      } else {
        limitNegativeDpDtBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/1kW/min  If the supervised power increases at a rate higher that the rate defined by these
     * limits, the ESS will discharge/charge at an opposite dp/dt to reduce (smooth) the rate of change at
     * the PCC
     * </pre>
     *
     * <code>.google.protobuf.FloatValue limitNegative_dp_dt = 2;</code>
     */
    public Builder mergeLimitNegativeDpDt(com.google.protobuf.FloatValue value) {
      if (limitNegativeDpDtBuilder_ == null) {
        if (((bitField0_ & 0x00000002) != 0) &&
          limitNegativeDpDt_ != null &&
          limitNegativeDpDt_ != com.google.protobuf.FloatValue.getDefaultInstance()) {
          getLimitNegativeDpDtBuilder().mergeFrom(value);
        } else {
          limitNegativeDpDt_ = value;
        }
      } else {
        limitNegativeDpDtBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/1kW/min  If the supervised power increases at a rate higher that the rate defined by these
     * limits, the ESS will discharge/charge at an opposite dp/dt to reduce (smooth) the rate of change at
     * the PCC
     * </pre>
     *
     * <code>.google.protobuf.FloatValue limitNegative_dp_dt = 2;</code>
     */
    public Builder clearLimitNegativeDpDt() {
      bitField0_ = (bitField0_ & ~0x00000002);
      limitNegativeDpDt_ = null;
      if (limitNegativeDpDtBuilder_ != null) {
        limitNegativeDpDtBuilder_.dispose();
        limitNegativeDpDtBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/1kW/min  If the supervised power increases at a rate higher that the rate defined by these
     * limits, the ESS will discharge/charge at an opposite dp/dt to reduce (smooth) the rate of change at
     * the PCC
     * </pre>
     *
     * <code>.google.protobuf.FloatValue limitNegative_dp_dt = 2;</code>
     */
    public com.google.protobuf.FloatValue.Builder getLimitNegativeDpDtBuilder() {
      bitField0_ |= 0x00000002;
      onChanged();
      return getLimitNegativeDpDtFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * uint/1kW/min  If the supervised power increases at a rate higher that the rate defined by these
     * limits, the ESS will discharge/charge at an opposite dp/dt to reduce (smooth) the rate of change at
     * the PCC
     * </pre>
     *
     * <code>.google.protobuf.FloatValue limitNegative_dp_dt = 2;</code>
     */
    public com.google.protobuf.FloatValueOrBuilder getLimitNegativeDpDtOrBuilder() {
      if (limitNegativeDpDtBuilder_ != null) {
        return limitNegativeDpDtBuilder_.getMessageOrBuilder();
      } else {
        return limitNegativeDpDt_ == null ?
            com.google.protobuf.FloatValue.getDefaultInstance() : limitNegativeDpDt_;
      }
    }
    /**
     * <pre>
     * uint/1kW/min  If the supervised power increases at a rate higher that the rate defined by these
     * limits, the ESS will discharge/charge at an opposite dp/dt to reduce (smooth) the rate of change at
     * the PCC
     * </pre>
     *
     * <code>.google.protobuf.FloatValue limitNegative_dp_dt = 2;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder> 
        getLimitNegativeDpDtFieldBuilder() {
      if (limitNegativeDpDtBuilder_ == null) {
        limitNegativeDpDtBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder>(
                getLimitNegativeDpDt(),
                getParentForChildren(),
                isClean());
        limitNegativeDpDt_ = null;
      }
      return limitNegativeDpDtBuilder_;
    }

    private com.google.protobuf.FloatValue limitPositiveDpDt_;
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder> limitPositiveDpDtBuilder_;
    /**
     * <pre>
     * uint/1kW/min  If the supervised power increases at a rate higher that the rate defined by these
     * limits, the ESS will discharge/charge at an opposite dp/dt to reduce (smooth) the rate of change at
     * the PCC
     * </pre>
     *
     * <code>.google.protobuf.FloatValue limitPositive_dp_dt = 3;</code>
     * @return Whether the limitPositiveDpDt field is set.
     */
    public boolean hasLimitPositiveDpDt() {
      return ((bitField0_ & 0x00000004) != 0);
    }
    /**
     * <pre>
     * uint/1kW/min  If the supervised power increases at a rate higher that the rate defined by these
     * limits, the ESS will discharge/charge at an opposite dp/dt to reduce (smooth) the rate of change at
     * the PCC
     * </pre>
     *
     * <code>.google.protobuf.FloatValue limitPositive_dp_dt = 3;</code>
     * @return The limitPositiveDpDt.
     */
    public com.google.protobuf.FloatValue getLimitPositiveDpDt() {
      if (limitPositiveDpDtBuilder_ == null) {
        return limitPositiveDpDt_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : limitPositiveDpDt_;
      } else {
        return limitPositiveDpDtBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * uint/1kW/min  If the supervised power increases at a rate higher that the rate defined by these
     * limits, the ESS will discharge/charge at an opposite dp/dt to reduce (smooth) the rate of change at
     * the PCC
     * </pre>
     *
     * <code>.google.protobuf.FloatValue limitPositive_dp_dt = 3;</code>
     */
    public Builder setLimitPositiveDpDt(com.google.protobuf.FloatValue value) {
      if (limitPositiveDpDtBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        limitPositiveDpDt_ = value;
      } else {
        limitPositiveDpDtBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/1kW/min  If the supervised power increases at a rate higher that the rate defined by these
     * limits, the ESS will discharge/charge at an opposite dp/dt to reduce (smooth) the rate of change at
     * the PCC
     * </pre>
     *
     * <code>.google.protobuf.FloatValue limitPositive_dp_dt = 3;</code>
     */
    public Builder setLimitPositiveDpDt(
        com.google.protobuf.FloatValue.Builder builderForValue) {
      if (limitPositiveDpDtBuilder_ == null) {
        limitPositiveDpDt_ = builderForValue.build();
      } else {
        limitPositiveDpDtBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/1kW/min  If the supervised power increases at a rate higher that the rate defined by these
     * limits, the ESS will discharge/charge at an opposite dp/dt to reduce (smooth) the rate of change at
     * the PCC
     * </pre>
     *
     * <code>.google.protobuf.FloatValue limitPositive_dp_dt = 3;</code>
     */
    public Builder mergeLimitPositiveDpDt(com.google.protobuf.FloatValue value) {
      if (limitPositiveDpDtBuilder_ == null) {
        if (((bitField0_ & 0x00000004) != 0) &&
          limitPositiveDpDt_ != null &&
          limitPositiveDpDt_ != com.google.protobuf.FloatValue.getDefaultInstance()) {
          getLimitPositiveDpDtBuilder().mergeFrom(value);
        } else {
          limitPositiveDpDt_ = value;
        }
      } else {
        limitPositiveDpDtBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/1kW/min  If the supervised power increases at a rate higher that the rate defined by these
     * limits, the ESS will discharge/charge at an opposite dp/dt to reduce (smooth) the rate of change at
     * the PCC
     * </pre>
     *
     * <code>.google.protobuf.FloatValue limitPositive_dp_dt = 3;</code>
     */
    public Builder clearLimitPositiveDpDt() {
      bitField0_ = (bitField0_ & ~0x00000004);
      limitPositiveDpDt_ = null;
      if (limitPositiveDpDtBuilder_ != null) {
        limitPositiveDpDtBuilder_.dispose();
        limitPositiveDpDtBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/1kW/min  If the supervised power increases at a rate higher that the rate defined by these
     * limits, the ESS will discharge/charge at an opposite dp/dt to reduce (smooth) the rate of change at
     * the PCC
     * </pre>
     *
     * <code>.google.protobuf.FloatValue limitPositive_dp_dt = 3;</code>
     */
    public com.google.protobuf.FloatValue.Builder getLimitPositiveDpDtBuilder() {
      bitField0_ |= 0x00000004;
      onChanged();
      return getLimitPositiveDpDtFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * uint/1kW/min  If the supervised power increases at a rate higher that the rate defined by these
     * limits, the ESS will discharge/charge at an opposite dp/dt to reduce (smooth) the rate of change at
     * the PCC
     * </pre>
     *
     * <code>.google.protobuf.FloatValue limitPositive_dp_dt = 3;</code>
     */
    public com.google.protobuf.FloatValueOrBuilder getLimitPositiveDpDtOrBuilder() {
      if (limitPositiveDpDtBuilder_ != null) {
        return limitPositiveDpDtBuilder_.getMessageOrBuilder();
      } else {
        return limitPositiveDpDt_ == null ?
            com.google.protobuf.FloatValue.getDefaultInstance() : limitPositiveDpDt_;
      }
    }
    /**
     * <pre>
     * uint/1kW/min  If the supervised power increases at a rate higher that the rate defined by these
     * limits, the ESS will discharge/charge at an opposite dp/dt to reduce (smooth) the rate of change at
     * the PCC
     * </pre>
     *
     * <code>.google.protobuf.FloatValue limitPositive_dp_dt = 3;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder> 
        getLimitPositiveDpDtFieldBuilder() {
      if (limitPositiveDpDtBuilder_ == null) {
        limitPositiveDpDtBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder>(
                getLimitPositiveDpDt(),
                getParentForChildren(),
                isClean());
        limitPositiveDpDt_ = null;
      }
      return limitPositiveDpDtBuilder_;
    }
    @java.lang.Override
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:essmodule.CapacityFirming)
  }

  // @@protoc_insertion_point(class_scope:essmodule.CapacityFirming)
  private static final openfmb.essmodule.CapacityFirming DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new openfmb.essmodule.CapacityFirming();
  }

  public static openfmb.essmodule.CapacityFirming getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<CapacityFirming>
      PARSER = new com.google.protobuf.AbstractParser<CapacityFirming>() {
    @java.lang.Override
    public CapacityFirming parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      Builder builder = newBuilder();
      try {
        builder.mergeFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(builder.buildPartial());
      } catch (com.google.protobuf.UninitializedMessageException e) {
        throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(e)
            .setUnfinishedMessage(builder.buildPartial());
      }
      return builder.buildPartial();
    }
  };

  public static com.google.protobuf.Parser<CapacityFirming> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<CapacityFirming> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public openfmb.essmodule.CapacityFirming getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

